<?php
/*
 * admin panel check functions
*/
$webpath = explode('application', __FILE__);
define('CACHE_PATH', $webpath[0]. 'temporary/cache/' );
//System Functions
class Topcmmchat_Controller_Action_Helper_ChatFun extends Topcmmchat_Controller_Action_Helper_RequestRemote
{
	function getConfig($table){
		$db = $table->getAdapter();
		$where = $db->quoteInto('id = ?', '1');
		$this->view->row = $row = $table->fetchRow($where);
	    return $row;
	}

	function getParam($param, $table){
	    $this->view->chat_Config = $chat_Config = $this->getConfig($table);
	    $paramval = $chat_Config->$param;
	    return $paramval;
	}

	function checkSlash($path)
	{
	    $path = trim($path);
	    if(substr($path,-1,1) != "/" && !empty($path))
	    {
	        $path = $path."/";
	    }
	    return $path;
	}

	function validate_data_api($data_api){
	    $da = 1;
	    if(substr(Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($data_api,0), 9, 3) == 200){
	        $da = 0;
	    }
	    return $da;
	}

	/**
	 * Check 123 FlashChat Client Location
	 * @parm $client_loc   Chat Client Location
	 * @return integer config status
	 */
	function validate_client($client_loc){
	    $c_own_loc = 1;
	    $swf = $client_loc . 'admin_123flashchat.swf';
	    if($headers = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($swf,0)){
	        $c_own_loc = (substr($headers, 9, 3) == '200') ? 0 : 1;
	    }
	    return $c_own_loc;
	}
	
	function getValid($chatSetting){
		$result = 1;	
		if($chatSetting['fc_server_host']){			
			if($chatSetting['fc_server_host'] == $_SERVER['SERVER_NAME']){
				$c_own_loc = $this->validate_client('http://'.$chatSetting['fc_server_host'].':35555/');
				if(!$c_own_loc){
					$result = 0;
				}
			}
		}else{
			$c_own_loc = $this->validate_client('http://'.$_SERVER['SERVER_NAME'].':35555/');
			if(!$c_own_loc){
				$result = 0;
			}
		}
		return $result;
	}


	function getChat($chatSetting){
		$chat = "";
	    if(!empty ($chatSetting)){
            if($chatSetting['clienttype'] == 'free'){
    			if($chatSetting['fullscreen'] == 1){
    				$chat .= '<script language="javascript">';
    				$chat .= 'var clientWidth = document.body.clientWidth;';
    				$chat .= 'var clientHeight = window.innerHeight;';			
    				$chat .= 'var htmlcode = \'<script language="javascript" src="'.$chatSetting['url'].'&width=\' + clientWidth;';
    				$chat .= 'htmlcode += \'&height=\' + clientHeight + \'"></sc\';';
    				$chat .= 'htmlcode += \'ript>\';';
    				$chat .= 'document.write(htmlcode);';
    				$chat .= '</script>';
    			}else{
    				$chat .= '<script language="javascript" src="'.$chatSetting['url'].'&width='.$chatSetting['width'].'&height='.$chatSetting['height'].'">';
    				$chat .= '<script>';
    				$chat .= 'document.getElementById("123flashchat").style.margin = "0 auto";';
    				$chat .= '</script>';
    			}
    		}elseif($chatSetting['clienttype'] == 'html'){
    		  
                $chat .= '<script src="'. $chatSetting['fc_client_loc'] .'123flashchat.js"></script>';
                $chat .= '<iframe width="'.$chatSetting['width'].'" height="'.$chatSetting['height'].'" src="'.$chatSetting['url'].'" vspale="0" scrolling="no" noresize="noresize" name="htmlchat" marginwidth="0" marginheight="0" framespacing="0" frameborder="0" border="0"></iframe>';
            }else{
                
                $chat .=  '<script src="'. $chatSetting['fc_client_loc'] .'123flashchat.js"></script><object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,19,0" width="'.$chatSetting['width'].'" height="'.$chatSetting['height'].'">
                    <param name=movie value="'.$chatSetting['url'].'">
                    <param name=quality value="high">
                    <param name="menu" value="false">
                    <param name="allowScriptAccess" value="always">
                    <embed src="'.$chatSetting['url'].'" allowScriptAccess="always" quality="high" menu="false" width="'.$chatSetting['width'].'" height="'.$chatSetting['height'].'" type="application/x-shockwave-flash" pluginspace="http://www.macromedia.com/go/getflashplayer"></embed>
                </object>';   
    		}           
	    }
        
	    return $chat;
	}


	function getChatSettings($table, $chat_Config = ""){
	    $url = "";
	    if(!is_array($chat_Config) || empty ($chat_Config)){
	        $chat_Config = $this->getConfig($table);
	    }
        
	    if($chat_Config) {
	       
	        $c_full = $this->getParam("fc_fullscreen", $table);
	        $server = $this->getParam('fc_extendserver', $table);
            $servertype = $this->getParam('fc_servertype', $table);
	        $lang = $this->getParam('fc_client_lang', $table);
	        $skin = $this->getParam('fc_client_skin', $table);
            $clienttype = $this->getParam('fc_clienttype', $table);
	        $fc_client_width = $this->getParam('fc_client_width', $table)."px";
	        $fc_client_height = $this->getParam('fc_client_height', $table)."px";

            if ($server != "2"){
    			if(($server == "1" && $clienttype == 1) || ($server == "0" && $servertype != 1 && $clienttype == 1)){
    				$client_name = '123flashchat.swf';
                    $client_type = 'flash';
    			}else{
    				$client_name = 'htmlchat/123flashchat.html';
                    $client_type = 'html';
    			}				
    			$url = $this->getParam('fc_client_loc', $table) . $client_name . "?init_host=" . $this->getParam('fc_server_host', $table) . "&init_port=" . $this->getParam('fc_server_port', $table) ;
    			$url .= ($this->getParam('fc_server_host_s', $table) ? '&init_host_s='.$this->getParam('fc_server_host_s', $table) : '') . ($this->getParam('fc_server_port_s', $table) ? '&init_port_s='.$this->getParam('fc_server_port_s', $table) : '');
    			$url .= ($this->getParam('fc_server_host_h', $table) ? '&init_host_h='.$this->getParam('fc_server_host_h', $table) : '') . ($this->getParam('fc_server_port_h', $table) ? '&init_port_h='.$this->getParam('fc_server_port_h', $table) : '');
    			$url .= ($server == "1") ? ("&init_group=" . $this->getParam('fc_group', $table)) : "";
    		}else{
    			$url = "http://free.123flashchat.com/js.php?room=" . $this->getParam('fc_room', $table) . "&skin="  . $skin . "&lang="  . $lang;
                $client_type = 'free';
            }
            
            if($c_full){
                $fc_client_width = '100%';
                $fc_client_height = '100%';
            }
                    
    		if ($room = isset($_GET['room'])?$_GET['room']:""){
    			$url .= "&init_room=" . $room;
    		}
	        if(isset($_SESSION['Zend_Auth']['storage'])){
	        	$user = Engine_Api::_()->user()->getUser($_SESSION['Zend_Auth']['storage']);
	        	if ($server == "2"){
	        		$url .= "&init_user=" . rawurlencode($user->username)."&init_password=";
	        	} else {
	        		$url .= "&init_user=" . rawurlencode($user->username) . "&init_password=" . rawurlencode($user->password);
	        	}
	        	$url .= "&init_nickname=".$user->displayname;
	        }
	    }else{
	        return false;
	    }	    
	    $chatSetting = array (
            "server"=>$server,
            'url' => $url,
            'width' => $fc_client_width,
            'height' => $fc_client_height,
    		'fullscreen' => $c_full,
            'clienttype' => $client_type,
    		'fc_client_loc' => $this->getParam('fc_client_loc', $table),
	    );
	    return $chatSetting;
	}

	function serviceGetChatStats($table){
		global $root_link;
		$pageurl=$_REQUEST['pid'];
//		$root_link=get_bloginfo('url')."/".$post_page_title_ID->post_name."/";
	    $sOutputCode = '';
	    $c_full = $this->getParam("fc_fullscreen", $table);
	    
	    if($c_full){
	        $fc_client_width = "screen.width";
	        $fc_client_height = "screen.height";
	    }else{
	        $fc_client_width = $this->getParam('fc_client_width', $table);
	        $fc_client_height = $this->getParam('fc_client_height', $table);
	    }
	    $status = $this->getStatus($table);
	    if ($this->getParam('fc_user_list', $table)){
	        $users  = $this->getUsers($table);
	    }
	    if (($this->getParam('fc_room_list', $table)) && ($this->getParam('fc_extendserver', $table) != "2")){
	        $rooms  = $this->getRooms($table);
	    }

	    if (isset($status['ln'])){
	        $sOutputCode .= '<b>' . $status['ln'] . '</b> login users.';
	        if (isset($status['rn'])) {
	            $sOutputCode = '<b>' . $status['rn'] . '</b> rooms, ' . '<b>' . $status['cn'] . '</b> connections, ' . $sOutputCode;
	        }
	    }
	    if(isset($rooms)) {
	        $sOutputCode .= "<b><p>Rooms:</b> ";
	        if(!$rooms){
	            $sOutputCode .= "None";
	        } else{
	            $xa = '';
	            foreach($rooms as $room){
	            	$sOutputCode .= $xa . '<a href="./topcmmchat?room=' . $room['id'] . '" target="_blank">' .$room['name'] .'</a>(' . $room['count'] . ')';
	            }
				$xa = ', ';
	        }

	    }
	    if(isset($users)){
	        $sOutputCode .= "</p><p><b>Users:</b> ";
	        if(!$users){
	            $sOutputCode .= "None</p>";
	        } else{
	            $xb = '';
	            foreach($users as $user){
	                $sOutputCode .= $xb . $user['name'];
	                $xb = ', ';
	            }
	            $sOutputCode .= "</p>";
	        }

	    }
	    $sOutputCode .= '&nbsp;&nbsp;<a href="./topcmmchat?room=" target="_blank"><b>Chat Now!</b></a></p>';
	    $sOutputCode = '<div class="dbContentHtml">' . $sOutputCode . '</div>';
	    return $sOutputCode;
	}

	function getStatus($table){
	    $data = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote(CACHE_PATH . "status.js",1);
	    $status_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$status_json){
	        $server =  $this->getParam('fc_extendserver', $table);
	        switch ($server){
	            case "0":
	                $status_js = $this->getParam('fc_api_url', $table) . "online.js";
	                if($rs = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($status_js,1)){
	                    $status_json = substr($rs,11,-1);
	                }
	                break;
	            case "1":
	                $status_js = $this->getParam('fc_api_url', $table) . "online.js?group=" . $this->getParam('fc_group', $table);
	                if($rs = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($status_js,1)){
	                    $status_json = substr($rs,11,-1);
	                }
	                break;
	            case "2":
	                $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $this->getParam('fc_room', $table);
	                if($rs = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($status_js,1)){
	                    preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	                    $status['ln'] = $matches[1];
	                    $status_json = json_encode($status);
	                }
	                break;
	        }
	        @file_put_contents(CACHE_PATH . "status.js",(time() + 120) . $status_json);
	    }
	    return json_decode($status_json,true);
	}

	function getRooms($table){
	    $data = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote("../".CACHE_PATH ."rooms.js", 1);
	    $rooms_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$rooms_json){
	        $server =  $this->getParam('fc_extendserver', $table);
	        switch ($server){
	            case "0":
	                $room_js = $this->getParam('fc_api_url', $table) . "rooms.js";
	                break;
	            case "1":
	                $room_js = $this->getParam('fc_api_url', $table) . "rooms.js?group=" . $this->getParam('fc_group', $table);
	                break;
	        }
	        if($rs = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($room_js,1)){
	            $rooms_json = substr($rs,10,-1);
	        }
	        @file_put_contents(CACHE_PATH ."rooms.js",(time() + 120) . $rooms_json);
	    }
	    return json_decode($rooms_json, true);
	}
	
	/**
	 * Function will get users;
	 */
	function getUsers($table){
	    $context = stream_context_create(array(
	            'http' => array(
	                    'timeout' => 3      // Timeout in seconds
	            )
	    ));
	    $data =  Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote(CACHE_PATH ."cache/users.js",1);
	    $users_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$users_json){
	        $server =  $this->getParam('fc_extendserver', $table);
	        switch ($server){
	            case "0":
	                $rooms = $this->getRooms($table);
	                $users = array();
	                foreach ($rooms as $room) {
	                    $user_js = $this->getParam('fc_api_url', $table) . "roomonlineusers.js?roomid=" . $room['id'];
	                    if($rs = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($user_js,1)){
	                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
	                    }
	                }
	                $users_json = json_encode($users);
	                break;
	            case "1":
	                $user_js = $this->getParam('fc_api_url', $table) . "roomonlineusers.js?group=" . $this->getParam('fc_group', $table);
	                if($rs = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($user_js,1)){
	                    $users_json = substr($rs,20,-1);
	                }
	                break;
	            case "2":
	                $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $this->getParam('fc_room', $table);
	                if($rs = Topcmmchat_Controller_Action_Helper_RequestRemote::requestRemote($user_js,1)){
	                    preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	                    foreach (explode(',', $matches[1]) as $user){
	                        $users[] = array('name' => $user);
	                    }
	                }
	                $users_json = json_encode($users);
	                break;
	        }
	        $users_json = $this->filterUserList($users_json);
	        @file_put_contents(CACHE_PATH ."users.js",(time() + 120) . $users_json);
	    }
	    return json_decode($users_json, true);
	}
	
	function filterUserList($users_json){
		$user_array =  json_decode($users_json,true);
		$user_regroup_array = array();
		$user_tmp_array = array();
		foreach($user_array as $key => $val){
			if (!in_array($val['name'], $user_tmp_array)){
				$user_tmp_array[] = $val['name'];
				$user_regroup_array[$key] = $user_array[$key];
			}
		}
		return json_encode($user_regroup_array);
	}

}

?>
