<?php
class Topcmmchat_Controller_Action_Helper_UserData
{
	private static $ACTION_QUERY = 0;
	private static $ACTION_ADD = 1;
	private static $ACTION_DELETE = 2;
	private static $ACTION_UPDATE = 3;


	private static $STRANGER = "stranger";
	private static $GENERAL = "general";

	private $removeFriendSql = "";
	private $queryFriendSql = "";
	private $db = "";

	public function Topcmmchat_Controller_Action_Helper_UserData()
	{
		$this->setXmlDoc();
		$this->action  = $this->setAction();
		//stranger  general
		$this->friendGroup = $this->setFriendGroup();
	}

	public function start($table)
	{
		switch($this->action)
		{
			case self::$ACTION_ADD:
				$this->addFriends($table);
				break;
			case self::$ACTION_DELETE:
				$this->removeFriends($table);
				break;
			case self::$ACTION_QUERY:
				$this->getFriendList($table, $this->queryFriendOne,self::$GENERAL);
				$this->getFriendListTwo($table, $this->opQueryFriendOne,self::$STRANGER,true);
				$this->doc->appendChild($this->UD);
				break;
			case self::$ACTION_UPDATE:
				if($this->friendGroup == self::$STRANGER)
				{
					$this->removeFriends($table);
				}
				else if($this->friendGroup == self::$GENERAL)
				{
					$this->addFriends($table);
				}
		}
		$this->outputXml();
	}

	private function addFriends($table)
	{
		if( $this->friendGroup == self::$STRANGER)
		{
				$this->responseSuccess();
		}
		else if($this->friendGroup == self::$GENERAL)
		{

			$getUserListOne = $table->fetchRow($this->selectUserListOne);
			$getUserListTwo = $table->fetchRow($this->selectUserListTwo);
			if($getUserListOne)
			{
				if($getUserListTwo)
				{
					$addFriendSqlThree = $table->update($this->addFriendSqlThree);
					$addFriendSqlFour = $table->update($this->addFriendSqlFour);
					if( $addFriendSqlThree && $addFriendSqlFour ){
						$this->responseSuccess();
					}else{
						$this->responseFailed();
					}
				}else{
					$addFriendSqlThree = $table->update($this->addFriendSqlThree);
					$addFriendSqlTwo = $table->insert($this->addFriendSqlTwo);
					if( $addFriendSqlThree && $addFriendSqlTwo ){
						$this->responseSuccess();
					}else{
						$this->responseFailed();
					}
				}
			}else{
				if($getUserListTwo)
				{
					$addFriendSqlOne = $table->insert($this->addFriendSqlOne);
					$addFriendSqlFour = $table->update($this->addFriendSqlFour);
					if( $addFriendSqlOne && $addFriendSqlFour ){
						$this->responseSuccess();
					}else{
						$this->responseFailed();
					}
				}else{
					$addFriendSqlOne = $table->insert($this->addFriendSqlOne);
					$addFriendSqlTwo = $table->insert($this->addFriendSqlTwo);
					if( $addFriendSqlOne && $addFriendSqlTwo ){
						$this->responseSuccess();
					}else{
						$this->responseFailed();
					}
				}
			}
		}else{
			$this->responseSuccess();
		}
	}

	private function removeFriends($table)
	{
		$this->view->getUserListOne = $getUserListOne = $table->fetchRow($this->selectUserListOne);
		$this->view->getUserListTwo = $getUserListTwo = $table->fetchRow($this->selectUserListTwo);
		if(empty($getUserListOne) && empty($getUserListTwo)){
			$this->responseSuccess();
		}
		else if(empty($getUserListOne) && !empty($getUserListTwo))
		{
			$removeFriendTwo = $table->delete($this->removeFriendTwo);
			if($removeFriendTwo){
				$this->responseSuccess();
			}else{
				$this->responseFailed();
			}
		}else if(!empty($getUserListOne) && empty($getUserListTwo)){
			$removeFriendOne = $table->delete($this->removeFriendOne);
			if($removeFriendOne){
				$this->responseSuccess();
			}else{
				$this->responseFailed();
			}
		}else if(!empty($getUserListOne) && !empty($getUserListTwo)){
			$removeFriendTwo = $table->delete($this->removeFriendTwo);
			$removeFriendOne = $table->delete($this->removeFriendOne);
			if($removeFriendOne && $removeFriendTwo ){
				$this->responseSuccess();
			}else{
				$this->responseFailed();
			}
		}else{
			$this->responseSuccess();
		}
	}

	private function getFriendList($table, $sql,$type,$checkRow = false)
	{
		$rss = $sql;
//var_dump($rss->user_id);exit;
		$d = false;
		if($rss)
		{
			$general = $this->doc->createElement("g");
			$general->setAttribute("n", $type);
			$this->view->row = $rows = $table->fetchAll($rss);
			 foreach( $rows as $row ) {
			 	$this->view->destuser = $destuser = Engine_Api::_()->user()->getUser($row->user_id);
			 	if(!$checkRow)
				{
					$d = true;
					$u = $this->doc->createElement("u");
					$u->setAttribute("n", $destuser->username);
					$u->setAttribute("nk", $destuser->displayname);
					$general->appendChild($u);
				}
			 }
			if(!$checkRow || $d)$this->FL->appendChild($general);
			$this->UD->appendChild($this->FL);
		}
	}

	private function getFriendListTwo($table, $sql,$type,$checkRow = false)
	{
		$rs = $sql;

		$d = false;

		if($rs)
		{
			$general = $this->doc->createElement("g");
			$general->setAttribute("n", $type);
			//$resultquery = mysql_query($this->queryFriendTwo);

			$this->view->row = $rows = $table->fetchAll($rs);
			 foreach( $rows as $row ) {
//			while($rss = mysql_fetch_array($rs)){

				$this->view->roww = $roww = Engine_Api::_()->user()->getUser($row->user_id);
					//if($checkRow) $rowexists = $this->checkRowExists($_GET['username'],$row['username']);s
				if($checkRow)
				{
					$d = true;
					$u = $this->doc->createElement("u");
					$u->setAttribute("n", $roww->username);
//					$u->setAttribute("nk", $roww['displayname']);
					$general->appendChild($u);
				}
			}


			if(!$checkRow || $d)$this->FL->appendChild($general);
			$this->UD->appendChild($this->FL);
		}
	}

	//select uselist

	public function selectUserListOne($sql)
	{
		$this->selectUserListOne = $sql;
	}

	public function selectUserListTwo($sql)
	{
		$this->selectUserListTwo = $sql;
	}

	//add

	public function addFriendSqlOne($sql)
	{
		$this->addFriendSqlOne = $sql;
	}

	public function addFriendSqlTwo($sql)
	{
		$this->addFriendSqlTwo = $sql;
	}

	public function addFriendSqlThree($sql)
	{
		$this->addFriendSqlThree = $sql;
	}

	public function addFriendSqlFour($sql)
	{
		$this->addFriendSqlFour = $sql;
	}

	//remove

	public function removeFriendOne($sql)
	{
		$this->removeFriendOne = $sql;
	}

	public function removeFriendTwo($sql)
	{
		$this->removeFriendTwo = $sql;
	}

	//query

	public function queryFriendOne($sql)
	{
		$this->queryFriendOne = $sql;
	}

	public function opQueryFriendOne($sql)
	{
		$this->opQueryFriendOne = $sql;
	}

	public function setUserNameRowField($field)
	{
		$this->userNameRowField = $field;
	}
	private function setAction()
	{
		if(!isset($_GET['action']))
		{
			$this->outputErrorMessage("Wrong parameter input");
		}
		else
		 return $_GET['action'];
	}

	private function setFriendGroup()
	{
			return $_GET['friendgroup'];
	}

	private function setXmlDoc()
	{
		$this->doc = new DOMDocument('1.0', 'utf-8');
		$this->FL = $this->doc->createElement('FL');
		$this->UD = $this->doc->createElement('UD');
	}

	private function responseSuccess()
	{
		$this->FL->setAttribute("r", 0);
		$this->doc->appendChild($this->FL);
				$this->outputXml();
				exit;
	}

	private function responseFailed()
	{
		$this->FL->setAttribute("r", 1);
		$this->doc->appendChild($this->FL);
		$this->outputXml();
				exit;
	}

	private function outputXml()
	{
		header("Content-Type: text/xml; charset=utf8");
		echo $this->doc->saveXml();
		exit;
	}

	private function outputErrorMessage($message)
	{
		exit($message);
	}

}
?>
